/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

#define INTERVAL   50    /* R}̃^C~O */
#define ARC        40    /* ~̃TCY */
#define LEFT        0    /* ̕ǂ x W */
#define RIGHT     400    /* E̕ǂ x W */
#define Y          80    /* ~ y W */
#define STEP        5    /* 1R}ňړ鋗 */
#define LtoR        0    /* ~̈ړ: E */
#define RtoL        1    /* ~̈ړ: E獶 */

static GC gc;
static XtIntervalId timeout_id;
static int position = LEFT;  /* ݂̉~ x W */
static int direction = LtoR;  /* LtoR: EɈړ, RtoL: Ɉړ */
static Pixmap front, back;  /* sbNX}bvEobt@ */
static Dimension width, height;

static void TimeoutCB(client_data, id)
    XtPointer     client_data;
    XtIntervalId *id;
{
    Widget w = (Widget)client_data;
    Pixmap tmp;

    /* (3) obt@NA */
    XSetForeground(XtDisplay(w), gc, WhitePixelOfScreen(XtScreen(w)));
    XFillRectangle(XtDisplay(w), back, gc, 0, 0, width, height);

    /* ̉~̈ʒu߂ */
    if (direction == LtoR) {             /* ܂ōEɓĂ */
        position += STEP;                /* ̈ʒuɐi߂ */
        if (position > (RIGHT - ARC)) {  /* ǂɓ甽] */
            position = (RIGHT - ARC) - (position - (RIGHT - ARC));
            direction = RtoL;
        }
    }
    else { /* direction == RtoL */  /* ܂ŉE獶ɓĂ */
        position -= STEP;           /* ̈ʒuɐi߂ */
        if (position < LEFT) {      /* ǂɓ甽] */
            position = LEFT - (position - LEFT);
            direction = LtoR;
        }
    }

    /* `~̐F͍ */
    XSetForeground(XtDisplay(w), gc, BlackPixelOfScreen(XtScreen(w)));
    /* (4) ̈ʒuɉ~` */
    XFillArc(XtDisplay(w), back, gc, position, Y, ARC, ARC, 0*64, 360*64);

    /* Ăу^CAEgER[obNĂяo悤ɂ */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(w),
                                 INTERVAL, TimeoutCB, w);

    /* (5) obt@؂ւ */
    tmp = front;
    front = back;
    back = tmp;

    /* (6) obt@̓eh[GAɃRs[ */
    XCopyArea(XtDisplay(w), front, XtWindow(w), gc, 0, 0, width, height, 0, 0);
}

/* (7) h[GAIoƁCobt@̓eRs[ */
static void ExposeCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    XCopyArea(XtDisplay(w), front, XtWindow(w), gc, 0, 0, width, height, 0, 0);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, canvas;
    Arg al[20];
    int ac;
    int depth;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Animation", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    canvas = XmCreateDrawingArea(panel, "canvas", al, ac);
    XtAddCallback(canvas, XmNexposeCallback, ExposeCB, NULL);
    XtManageChild(canvas);

    XtRealizeWidget(toplevel);

    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);

    /* h[GÃEBhẼTCY depth 𒲂ׂ */
    XtVaGetValues(canvas, XmNwidth, &width,
                          XmNheight, &height,
                          XmNdepth, &depth, NULL);

    /* (1) h[GAƓTCY depth ŃsbNX}bv 2쐬 */
    front = XCreatePixmap(XtDisplay(canvas), XtWindow(canvas),
                          width, height, depth);
    back = XCreatePixmap(XtDisplay(canvas), XtWindow(canvas),
                         width, height, depth);

    /* (2) sbNX}bvNAĂ (œhԂ) */
    XSetForeground(XtDisplay(canvas), gc, WhitePixelOfScreen(XtScreen(canvas)));
    XFillRectangle(XtDisplay(canvas), front, gc, 0, 0, width, height);
    XFillRectangle(XtDisplay(canvas), back, gc, 0, 0, width, height);

    /* ^CAEgER[obNo^ */
    timeout_id = XtAppAddTimeOut(app_context, INTERVAL, TimeoutCB, canvas);

    XtAppMainLoop(app_context);
}
